<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Auth_aaa Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284028"></a>Auth_aaa Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Jan</span> <span class="surname">Janak</span></h3><div class="affiliation"><span class="orgname">FhG Fokus<br></span></div><code class="email">&lt;<a class="email" href="mailto:jan@iptel.org">jan@iptel.org</a>&gt;</code></div><div class="author"><h3 class="author"><span class="firstname">Juha</span> <span class="surname">Heinanen</span></h3><div class="affiliation"><span class="orgname">Song Networks<br></span></div><code class="email">&lt;<a class="email" href="mailto:jh@song.fi">jh@song.fi</a>&gt;</code></div><div class="author"><h3 class="author"><span class="firstname">Stelios</span> <span class="surname">Sidiroglou-Douskos</span></h3></div><div class="author"><h3 class="author"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3><code class="email">&lt;<a class="email" href="mailto:bogdan@opensips.org">bogdan@opensips.org</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Jan</span> <span class="surname">Janak</span></h3><code class="email">&lt;<a class="email" href="mailto:jan@iptel.org">jan@iptel.org</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Irina-Maria</span> <span class="surname">Stanescu</span></h3><code class="email">&lt;<a class="email" href="mailto:ironmissy@gmail.com">ironmissy@gmail.com</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2002, 2003 FhG FOKUS</p></div><div><p class="copyright">Copyright © 2005, 2009 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id277967">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id276746">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id277170">1.2. Additional Credentials</a></span></dt><dt><span class="section"><a href="#id248854">1.3. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248860">1.3.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249657">1.3.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249668">1.4. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249674">1.4.1. <code class="varname">aaa_url</code> (string)</a></span></dt><dt><span class="section"><a href="#id249705">1.4.2. <code class="varname">service_type</code> (integer)</a></span></dt><dt><span class="section"><a href="#id293431">1.4.3. <code class="varname">use_ruri_flag</code> (string/integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293469">1.5. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293475">1.5.1. <code class="function">aaa_www_authorize(realm[, uri_user])</code></a></span></dt><dt><span class="section"><a href="#id293593">1.5.2. <code class="function">aaa_proxy_authorize(realm [, uri_user])</code></a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248024">&#8220;<span class="quote">SIP-AVP</span>&#8221; AAA AVP examples</a></dt><dt>1.2. <a href="#id249691"><code class="varname">aaa_url</code> parameter usage</a></dt><dt>1.3. <a href="#id293416"><code class="varname">service_type</code> parameter usage</a></dt><dt>1.4. <a href="#id293453"><code class="varname">use_ruri_flag</code> parameter usage</a></dt><dt>1.5. <a href="#id293575"><code class="function">aaa_www_authorize</code> usage</a></dt><dt>1.6. <a href="#id293661"><code class="function">proxy_authorize</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id277967"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id276746"></a>1.1. Overview</h2></div></div></div><p>
		This module contains functions that are used to perform authentication 
		using an AAA server. Basically the proxy will pass along the 
		credentials to the AAA server which will in turn send a reply 
		containing result of the authentication. So basically the whole
		authentication is done in the AAA server. Before sending the request 
		to the AAA server we perform some sanity checks over the 
		credentials to make sure that only well formed credentials will get to 
		the server. We have implemented AAA authentication according to 
		draft-sterman-aaa-sip-00.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id277170"></a>1.2. Additional Credentials</h2></div></div></div><p>
		When performing authentication, the AAA server may include in the
		response additional credentials. This scheme is very useful in fetching
		additional user information from the AAA server without making
		extra queries.
	</p><p>
		The additional credentials are embedded in the AAA reply as AVPs 
		&#8220;<span class="quote">SIP-AVP</span>&#8221;. The syntax of the value is:
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>
			value = SIP_AVP_NAME SIP_AVP_VALUE
			</em></span></p></li><li><p><span class="emphasis"><em>
			SIP_AVP_NAME = STRING_NAME | '#'ID_NUMBER
			</em></span></p></li><li><p><span class="emphasis"><em>
			SIP_AVP_VALUE = ':'STRING_VALUE | '#'NUMBER_VALUE
			</em></span></p></li></ul></div><p>
	</p><p>
		All additional credentials will be stored as OpenSIPS AVPs
		(SIP_AVP_NAME = SIP_AVP_VALUE).
	</p><p>
		The RPID value may be fetch via this mechanism.
	</p><div class="example"><a name="id248024"></a><p class="title"><b>Example 1.1. &#8220;<span class="quote">SIP-AVP</span>&#8221; AAA AVP examples</b></p><div class="example-contents"><pre class="programlisting">
....
"email:joe@yahoo.com"
    - STRING NAME AVP (email) with STRING VALUE (joe@yahoo.com)
"#14:joe@yahoo.com"
    - ID AVP (14) with STRING VALUE (joe@yahoo.com)
"age#28"
    - STRING NAME AVP (age) with INTEGER VALUE (28)
"#14#28"
    - ID AVP (14) with INTEGER VALUE (28)
....
		</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248854"></a>1.3. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248860"></a>1.3.1. OpenSIPS Modules</h3></div></div></div><p>
			The module depends on the following modules (in the other words 
			the listed modules must be loaded before this module):
			</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>auth</em></span> -- Generic authentication 
				functions</p></li><li><p><span class="emphasis"><em>an aaa implementing module</em></span> -- for example aaa_radius</p></li></ul></div><p>
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249657"></a>1.3.2. External Libraries or Applications</h3></div></div></div><p>
			This module does not depend on any external library.
			</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249668"></a>1.4. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249674"></a>1.4.1. <code class="varname">aaa_url</code> (string)</h3></div></div></div><p>
		This is the url representing the AAA protocol used and the location of the configuration file of this protocol.
		</p><p>
		The syntax for the url is the following: "name_of_the_aaa_protocol_used:path_of_the_configuration_file"
		</p><div class="example"><a name="id249691"></a><p class="title"><b>Example 1.2. <code class="varname">aaa_url</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
		
modparam("auth_aaa", "aaa_url", "radius:/etc/radiusclient-ng/radiusclient.conf")
		</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249705"></a>1.4.2. <code class="varname">service_type</code> (integer)</h3></div></div></div><p>
		This is the value of the Service-Type aaa attribute to be used. 
		The default should be fine for most people. See your aaa client 
		include files for numbers to be put in this parameter if you need 
		to change it.
		</p><p>
		Default value is &#8220;<span class="quote">15</span>&#8221;.
		</p><div class="example"><a name="id293416"></a><p class="title"><b>Example 1.3. <code class="varname">service_type</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
		
modparam("auth_aaa", "service_type", 15)
		</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293431"></a>1.4.3. <code class="varname">use_ruri_flag</code> (string/integer)</h3></div></div></div><p>
                When this parameter is set to the value other than "NULL" and the
                request being authenticated has flag with matching number set
                via setflag() function, use Request URI instead of uri parameter
                value from the Authorization / Proxy-Authorization header field
                to perform AAA authentication.  This is intended to provide
                workaround for misbehaving NAT / routers / ALGs that alter request
                in the transit, breaking authentication.  At the time of this
                writing, certain versions of Linksys WRT54GL are known to do that.
                </p><p>
                Default value is &#8220;<span class="quote">NULL</span>&#8221; (not set).
                </p><div class="example"><a name="id293453"></a><p class="title"><b>Example 1.4. <code class="varname">use_ruri_flag</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
		
modparam("auth_aaa", "use_ruri_flag", "USE_RURI_FLAG")
                </pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293469"></a>1.5. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293475"></a>1.5.1. <code class="function">aaa_www_authorize(realm[, uri_user])</code></h3></div></div></div><p>
		The function verifies credentials according to 
		<a class="ulink" href="http://www.ietf.org/rfc/rfc2617.txt" target="_top">RFC2617</a>. If 
		the credentials are verified successfully then the function will 
		succeed and mark the credentials as authorized (marked credentials can 
		be later used by some other functions). If the function was unable to 
		verify the credentials for some reason then it will fail and
		the script should call
		<code class="function">www_challenge</code>
		which will challenge the user again.
		</p><p>Negative codes may be interpreted as follows:</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>-5 (generic error)</em></span> - some generic error
			occurred and no reply was sent out;
			</p></li><li><p>
			<span class="emphasis"><em>-4 (no credentials)</em></span> - credentials were not
			found in request;
			</p></li><li><p>
			<span class="emphasis"><em>-3 (stale nonce)</em></span> - stale nonce;
			</p></li></ul></div><p>
		This function will, in fact, perform sanity checks over the received 
		credentials and then pass them along to the aaa server which will 
		verify the credentials and return whether they are valid or not.
		</p><p>Meaning of the parameter is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>realm</em></span> - Realm is a opaque string that 
			the user agent should present to the user so he can decide what 
			username and password to use. Usually this is domain of the host 
			the server is running on.
			</p><p>
			If an empty string &#8220;<span class="quote"></span>&#8221; is used then the server will 
			generate it from the request. In case of REGISTER requests To 
			header field domain will be used (because this header field 
			represents a user being registered), for all other messages From 
			header field domain will be used.
			</p><p>
			The string may contain pseudo variables.
			</p></li><li><p><span class="emphasis"><em>uri_user</em></span> - Uri_user is an
			optional pseudo variable parameter whose value, if
			present, will be given to Radius server as value of
			SIP-URI-User check item.
			If uri_user pseudo variable parameter is not
			present, the server will generate 
			SIP-URI-User check item value from user part of
			To URI.
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id293575"></a><p class="title"><b>Example 1.5. <code class="function">aaa_www_authorize</code> usage</b></p><div class="example-contents"><pre class="programlisting">
		
...
if (!aaa_www_authorize("siphub.net")) {
	www_challenge("siphub.net", "1");
};
...

</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293593"></a>1.5.2. <code class="function">aaa_proxy_authorize(realm [, uri_user])</code></h3></div></div></div><p>
		The function verifies credentials according to 
		<a class="ulink" href="http://www.ietf.org/rfc/rfc2617.txt" target="_top">RFC2617</a>. If 
		the credentials are verified successfully then the function will 
		succeed and mark the credentials as authorized (marked credentials can 
		be later used by some other functions). If the function was unable to 
		verify the credentials for some reason then it will fail and the script 
		should call <code class="function">proxy_challenge</code> which 
		will challenge the user again. For more about the negative return 
		codes, see the above function.
		</p><p>
		This function will, in fact, perform sanity checks over the received 
		credentials and then pass them along to the aaa server which will 
		verify the credentials and return whether they are valid or not.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>realm</em></span> - Realm is a opaque string that 
			the user agent should present to the user so he can decide what 
			username and password to use.  This is usually
			one of the domains the proxy is responsible for.
			If an empty string &#8220;<span class="quote"></span>&#8221; is used then the server will 
			generate realm from host part of From header field URI.
			</p><p>
			The string may contain pseudo variables.
			</p></li><li><p><span class="emphasis"><em>uri_user</em></span> - Uri_user is an
			optional pseudo variable parameter whose value, if
			present, will be given to Radius server as value of
			SIP-URI-User check item.
			If uri_user pseudo variable parameter is not
			present, the server will generate 
			SIP-URI-User check item value from user part of
			From URI.
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id293661"></a><p class="title"><b>Example 1.6. <code class="function">proxy_authorize</code> usage</b></p><div class="example-contents"><pre class="programlisting">
		
...
if (!aaa_proxy_authorize("")) {   # Realm and URI user will be autogenerated
	proxy_challenge("", "1");
};
...
if (!aaa_proxy_authorize("$pd", "$pU")) { # Realm and URI user are taken
	proxy_challenge("$pd", "1");         # from P-Preferred-Identity
};                                           # header field
...

</pre></div></div><br class="example-break"></div></div></div></div></body></html>
