<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>mi_xmlrpc_ng Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284028"></a>mi_xmlrpc_ng Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Ovidiu</span> <span class="surname">Sas</span></h3><code class="email">&lt;<a class="email" href="mailto:osas@voipembedded.com">osas@voipembedded.com</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Ovidiu</span> <span class="surname">Sas</span></h3></div></div></div><div><p class="copyright">Copyright © 2013 
		<a class="ulink" href="http://www.voipembedded.com" target="_top">VoIP Embedded, Inc.</a>
	    </p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Rev$</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id268446">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id275730">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id276089">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id284072">1.2.1. External Libraries or Applications</a></span></dt><dt><span class="section"><a href="#id249053">1.2.2. OpenSIPS Modules</a></span></dt></dl></dd><dt><span class="section"><a href="#id248008">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248014">1.3.1. <code class="varname">mi_xmlrpc_ng_root</code>(string)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249585">1.4. Exported Functions</a></span></dt><dt><span class="section"><a href="#id249595">1.5. Known issues</a></span></dt><dt><span class="section"><a href="#id249610">1.6. Example</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248032">Set <code class="varname">mi_xmlrpc_ng_root</code> parameter</a></dt><dt>1.2. <a href="#id249622">XMLRPC request</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id268446"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id275730"></a>1.1. Overview</h2></div></div></div><p>
		This module implements a xmlrpc server that handles xmlrpc
		requests and generates xmlrpc responses.
		When a xmlrpc message is received a default method is executed.
	</p><p>
		At first, it looks up the MI command.
		If found it parses the called procedure's parameters
		into a MI tree and the command is executed.
		A MI reply tree is returned that is formatted back in xmlrpc.
		The response is built in two ways - like a string that
		contains the MI tree nodes information (name, values and
		attributes) or like an array whose elements are consisted
		of each MI tree node stored information.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id276089"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id284072"></a>1.2.1. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before
		running OpenSIPS with this module loaded:
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>libxml2</em></span></p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249053"></a>1.2.2. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>httpd</em></span> module.</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248008"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248014"></a>1.3.1. <code class="varname">mi_xmlrpc_ng_root</code>(string)</h3></div></div></div><p>
		Specifies the root path for xmlrpc requests:
		http://[opensips_IP]:[opensips_httpd_port]/[mi_xmlrpc_ng_root]
		</p><p>
		<span class="emphasis"><em>The default value is "xmlrpc".</em></span>
		</p><div class="example"><a name="id248032"></a><p class="title"><b>Example 1.1. Set <code class="varname">mi_xmlrpc_ng_root</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_xmlrpc_ng", "mi_xmlrpc_ng_root", "opensips_mi_xmlrpc")
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249585"></a>1.4. Exported Functions</h2></div></div></div><p>
		No function exported to be used from configuration file.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249595"></a>1.5. Known issues</h2></div></div></div><p>
		Commands with large responses (like ul_dump) will fail if the
		configured size of the httpd buffer is to small (or if there
		isn't enough pkg memory configured).
		</p><p>
		Future realeases of the httpd and mi_xmlrpc_ng modules
		will address this issue.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249610"></a>1.6. Example</h2></div></div></div><p>
		This is an example showing the xmlrpc format for the
		&#8220;<span class="quote">get_statistics net: uri:</span>&#8221; MI commad:
		response.
		</p><div class="example"><a name="id249622"></a><p class="title"><b>Example 1.2. XMLRPC request</b></p><div class="example-contents"><pre class="programlisting">

POST /xmlrpc HTTP/1.0
Host: my.host.com
User-Agent: My xmlrpc UA
Content-Type: text/xml
Content-Length: 216

&lt;?xml version='1.0'?&gt;
&lt;methodCall&gt;
	&lt;methodName&gt;get_statistics&lt;/methodName&gt;
	&lt;params&gt;
		&lt;param&gt;
			&lt;value&gt;&lt;string&gt;net:&lt;/string&gt;&lt;/value&gt;
		&lt;/param&gt;
		&lt;param&gt;
			&lt;value&gt;&lt;string&gt;uri:&lt;/string&gt;&lt;/value&gt;
		&lt;/param&gt;
	&lt;/params&gt;
&lt;/methodCall&gt;


HTTP/1.0 200 OK
Content-Length: 236
Content-Type: text/xml; charset=utf-8
Date: Mon, 8 Mar 2013 12:00:00 GMT

&lt;?xml version="1.0" encoding="UTF-8"?&gt;&lt;methodResponse&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;string&gt;
:: net:waiting_udp = 0
:: net:waiting_tcp = 0
:: uri:positive checks = 0
:: uri:negative_checks = 0
&lt;/string&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodResponse&gt;

</pre></div></div><br class="example-break"></div></div></div></body></html>
